﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.8
@EndOfDesignText@
Sub Process_Globals
	Private fx As JFX
	Private xui As XUI
	Public pressedX As Double
	Public pressedY As Double
End Sub

Public Sub add_new_pane As Node
	Dim td As tagdata
	td.PressedX = 0
	td.PressedY = 0
	td.count = Main.nodecnt
	td.id = "Pane" & Main.nodecnt
	Dim newpnl As Pane
	newpnl.Initialize("pnl")
	newpnl.SetSize(100,60)
	newpnl.Top = 80
	newpnl.Left = 20
	newpnl.Id = "Pane" & Main.nodecnt
	CSSUtils.SetBorder(newpnl,1,fx.Colors.Black,3)
	Dim red As Int = Rnd(150,250)
	Dim green As Int = Rnd(150,250)
	Dim blue As Int = Rnd(150,250)
	CSSUtils.SetBackgroundColor(newpnl, fx.Colors.ARGB(255,red,green,blue))
	td.brdthick = 1
	td.brdcolor = xui.PaintOrColorToColor(fx.Colors.Black)
	td.brdradius = 3
	td.backcolor = xui.PaintOrColorToColor(fx.Colors.ARGB(255,red,green,blue))
	td.noborder = False
	td.fontfamily = "Verdana"
	td.fontsize = 15
	td.isbold = "false"
	td.isitalic = "false"
	td.alignment = "TOP_LEFT"
	td.textcolor = xui.PaintOrColorToColor(fx.Colors.Black)
	td.imgurl = ""
	td.comptype = "Pane"
	newpnl.Tag = td
	'newpnl = set_pane_contextmenu(newpnl)
	Main.panemain.AddNode(newpnl,newpnl.Left,newpnl.top,100,60)
	Main.nodecnt = Main.nodecnt + 1
	Main.currnode = newpnl
	Return newpnl
End Sub
Public Sub add_canvas_node(strtype As String) As Node
	Main.cboxfill.Checked = True
	Dim td As tagdata
	td.PressedX = 0
	td.PressedY = 0
	td.count = Main.nodecnt
	td.id = "Canvas" & Main.nodecnt
	Dim newpnl As Pane
	newpnl.Initialize("pnl")
	newpnl.SetSize(100,60)
	newpnl.Top = 80
	newpnl.Left = 20
	newpnl.Id = "Pane" & Main.nodecnt
	td.brdthick = 0
	td.brdcolor = xui.PaintOrColorToColor(fx.Colors.Black)
	td.brdradius = 0
	td.backcolor = xui.PaintOrColorToColor(fx.Colors.Transparent)
	td.noborder = True
	td.fontfamily = "Verdana"
	td.fontsize = 15
	td.isbold = "false"
	td.isitalic = "false"
	td.alignment = "TOP_LEFT"
	td.textcolor = xui.PaintOrColorToColor(fx.Colors.Black)
	td.imgurl = ""
	td.comptype = "Canvas"
	td.nofill = True
	td.drawing = strtype
	Main.panemain.AddNode(newpnl,newpnl.Left,newpnl.top,100,60)
	Main.nodecnt = Main.nodecnt + 1
	Dim pcnvs As B4XCanvas
	pcnvs.Initialize(newpnl)
	pcnvs.Resize(newpnl.PrefWidth,newpnl.PrefHeight)
	Select strtype
		Case "arrow-up"
			drawings_module.draw_arrow_up(pcnvs,newpnl,td)
		Case "arrow-down"
			drawings_module.draw_arrow_down(pcnvs,newpnl,td)
		Case "arrow-left"
			drawings_module.draw_arrow_left(pcnvs,newpnl,td)
		Case "arrow-right"
			drawings_module.draw_arrow_right(pcnvs,newpnl,td)
		Case "bitmap"
			drawings_module.draw_bitmap(pcnvs,newpnl,td,"add")
		Case "circle"
			drawings_module.draw_circle(pcnvs,newpnl,td)
		Case "diamond"
			drawings_module.draw_diamond(pcnvs,newpnl,td)
		Case "Hline"
			drawings_module.draw_Hline(pcnvs,newpnl,td)
		Case "Vline"
			drawings_module.draw_Vline(pcnvs,newpnl,td)
		Case "rectangle"
			drawings_module.draw_rectangle(pcnvs,newpnl,td)
		Case "text"
			drawings_module.draw_text(pcnvs,newpnl,td,"add")
	End Select
	pcnvs.Invalidate
	td.cnvs = pcnvs
	newpnl.Tag = td
	Main.currnode = newpnl
	Return newpnl
End Sub
public Sub set_canvas_drawing(newpnl As Pane,strtype As String,td As tagdata) As tagdata
	newpnl.RemoveAllNodes
	Dim pcnvs As B4XCanvas
	pcnvs.Initialize(newpnl)
	pcnvs.Resize(newpnl.PrefWidth,newpnl.PrefHeight)
	Select strtype
		Case "arrow-up"
			drawings_module.draw_arrow_up(pcnvs,newpnl,td)
		Case "arrow-down"
			drawings_module.draw_arrow_down(pcnvs,newpnl,td)
		Case "arrow-left"
			drawings_module.draw_arrow_left(pcnvs,newpnl,td)
		Case "arrow-right"
			drawings_module.draw_arrow_right(pcnvs,newpnl,td)
		Case "bitmap"
			drawings_module.draw_bitmap(pcnvs,newpnl,td,"set")
		Case "circle"
			drawings_module.draw_circle(pcnvs,newpnl,td)
		Case "diamond"
			drawings_module.draw_diamond(pcnvs,newpnl,td)
		Case "Hline"
			drawings_module.draw_Hline(pcnvs,newpnl,td)
		Case "Vline"
			drawings_module.draw_Vline(pcnvs,newpnl,td)
		Case "rectangle"
			drawings_module.draw_rectangle(pcnvs,newpnl,td)
		Case "text"
			drawings_module.draw_text(pcnvs,newpnl,td,"set")
	End Select
	pcnvs.Invalidate
	td.cnvs = pcnvs
	Return td
End Sub

Public Sub resize_pane(ParentX As Double, ParentY As Double)
	Dim gap As Int = 5
	Dim minwidth As Int = Main.edgewidth * 4
	Dim minheight As Int = Main.edgewidth * 4
	If Main.resizing = True Then
		If Main.lxpos > 0 And Main.lypos > 0 Then
			If Main.xpress <= Main.edgewidth Then	' left edge
				If Main.lxpos > ParentX Then	' moving left
					If Main.currpane.Left - gap > 0 Then
						Main.currpane.Left = Main.currpane.Left - gap
						Main.currpane.prefWidth = Main.currpane.Width + gap
					End If
				Else	' moving right
					If Main.currpane.Width - gap > minwidth Then
						Main.currpane.Left = Main.currpane.Left + gap
						Main.currpane.prefWidth = Main.currpane.Width - gap
					End If
				End If
			End If
			If Main.xpress >= (Main.currpane.Width - Main.edgewidth) And Main.xpress < Main.currpane.Width Then	' right edge
				If Main.lxpos > ParentX Then	' moving left
					If Main.currpane.Width > minwidth Then
						Main.currpane.prefWidth = Main.currpane.Width - gap
						Main.xpress = Main.xpress - gap
					End If
				Else	' moving right
					If Main.currpane.Width + Main.currpane.Left < Main.panemain.Width Then
						Main.currpane.prefWidth = Main.currpane.Width + gap
						Main.xpress = Main.xpress + gap
					End If
				End If
			End If
			If Main.ypress <= Main.edgewidth Then	'top edge
				If Main.lypos > ParentY Then	' moving up
					If Main.currpane.Top - gap > 0 Then
						Main.currpane.Top = Main.currpane.Top - gap
						Main.currpane.prefHeight = Main.currpane.Height + gap
					End If
				Else	' moving down
					If Main.currpane.Height - gap > minheight Then
						Main.currpane.Top = Main.currpane.Top + gap
						Main.currpane.PrefHeight = Main.currpane.Height - gap
					End If
				End If
			End If
			If Main.ypress >= (Main.currpane.Height - Main.edgewidth) And Main.ypress < Main.currpane.Height Then	' bottom edge
				If Main.lypos > ParentY Then	' moving up
					If Main.currpane.Height > minheight Then
						Main.currpane.prefHeight = Main.currpane.Height - gap
						Main.ypress = Main.ypress - gap
					End If
				Else	'moving down
					If Main.currpane.Height + Main.currpane.Top < Main.panemain.Height Then
						Main.currpane.prefHeight = Main.currpane.Height + gap
						Main.ypress = Main.ypress + gap
					End If
				End If
			End If
		End If
	End If
	Dim td As tagdata = Main.currpane.Tag
	If (td.drawing <> Null) And (td.drawing <> "null") Then
		Dim td As tagdata = Main.currpane.Tag
		If td.drawing <> Null Then
			If td.cnvs <> Null Then
				Dim ncnvs As B4XCanvas = td.cnvs
				ncnvs.ClearRect(ncnvs.TargetRect)
				ncnvs.Invalidate
			End If
		End If
		ncnvs.Initialize(Main.currpane)
		ncnvs.Resize(Main.currpane.PrefWidth,Main.currpane.PrefHeight)
		Select td.drawing
			Case "arrow-up"
				drawings_module.draw_arrow_up(ncnvs,Main.currpane,td)
			Case "arrow-down"
				drawings_module.draw_arrow_down(ncnvs,Main.currpane,td)
			Case "arrow-left"
				drawings_module.draw_arrow_left(ncnvs,Main.currpane,td)
			Case "arrow-right"
				drawings_module.draw_arrow_right(ncnvs,Main.currpane,td)
			Case "bitmap"
				drawings_module.draw_bitmap(ncnvs,Main.currpane,td,"resize")
			Case "circle"
				drawings_module.draw_circle(ncnvs,Main.currpane,td)
			Case "diamond"
				drawings_module.draw_diamond(ncnvs,Main.currpane,td)
			Case "Hline"
				drawings_module.draw_Hline(ncnvs,Main.currpane,td)
			Case "Vline"
				drawings_module.draw_Vline(ncnvs,Main.currpane,td)
			Case "rectangle"
				drawings_module.draw_rectangle(ncnvs,Main.currpane,td)
			Case "text"
				drawings_module.draw_text(ncnvs,Main.currpane,td,"resize")
		End Select
		ncnvs.Invalidate
		td.cnvs = ncnvs
	End If
End Sub

Public Sub load_pane(td As tagdata,valuesmap As Map)
	Dim newpnl As Pane
	newpnl.Initialize("pnl")
	newpnl.Top = valuesmap.Get("top")
	newpnl.Left = valuesmap.Get("left")
	newpnl.prefwidth = valuesmap.Get("width")
	newpnl.prefheight = valuesmap.Get("height")
	' color and border settings from td!
	td.noborder = valuesmap.Get("noborder")
	If valuesmap.ContainsKey("nofill") Then td.nofill = valuesmap.Get("nofill")
	newpnl.Tag = td
	newpnl.Id = td.id
	If td.noborder = "false" Then CSSUtils.SetBorder(newpnl,td.brdthick,fx.Colors.From32Bit(td.brdcolor),td.brdradius)
	If td.gradient1 <> "null" And td.gradient2 <> "null" Then
		If td.gradienthorz = True Then
			CSSUtils.SetStyleProperty(newpnl,"-fx-background-color","linear-gradient(to right,"& td.gradient1 & "," & td.gradient2 & ")")
		Else
			CSSUtils.SetStyleProperty(newpnl,"-fx-background-color","linear-gradient(to bottom,"& td.gradient1 & "," & td.gradient2 & ")")
		End If
	Else
		CSSUtils.SetBackgroundColor(newpnl, fx.Colors.From32Bit(td.backcolor))
	End If
	If td.imgurl <> "" Then
		If td.imgurl.Contains("/") Then
			Dim folder As String = td.imgurl.SubString2(0,td.imgurl.LastIndexOf("/"))
			Dim fname As String = td.imgurl.SubString(td.imgurl.LastIndexOf("/")+1)
			CSSUtils.SetBackgroundImage(newpnl,folder,fname)
		Else
			CSSUtils.SetBackgroundImage(newpnl,Main.imagefilesfolder,td.imgurl)
		End If
	End If
	If td.id.Contains("Canvas") Then
		Dim strtype As String = td.drawing
		td = set_canvas_drawing(newpnl,strtype,td)
		newpnl.Tag = td
	End If
	Dim vw As B4XView = newpnl
	vw.Rotation = td.rotation
	newpnl = vw
	Main.panemain.AddNode(newpnl,newpnl.Left,newpnl.Top,newpnl.prefWidth,newpnl.prefHeight)
End Sub

Public Sub attach_node_to_pane
	If Main.currnode.IsInitialized Then
		detach_node_from_pane
		Dim td1 As tagdata = Main.currnode.Tag
		If td1.id.Contains("Pane") Then			'Or td1.id.Contains("Canvas") Then
			Dim pn As Pane = Main.currnode
		Else
			Return
		End If
		For Each nod As Node In Main.panemain.GetAllViewsRecursive
			If nod.Tag <> "" Then
				Dim td As tagdata = nod.Tag
				If td.id <> td1.id Then
					If td.parent = Null Or td.parent = "null" Then
						If nod.Left >= pn.Left And nod.Top >= pn.Top Then
							If nod.Left+nod.prefWidth <= pn.Left+pn.Width And nod.Top+nod.prefHeight <= pn.Top+pn.Height Then
								pn.AddNode(nod,nod.Left-pn.Left,nod.Top-pn.Top,nod.PrefWidth,nod.PrefHeight)
								td.parent = td1.id
								nod.Tag = td
							End If
						End If
					End If
				End If
			End If
		Next
	End If
	component_info_module.fill_tv1
End Sub
Public Sub detach_node_from_pane
	If Main.currnode.IsInitialized Then
		Dim currtd As tagdata = Main.currnode.Tag
		For Each nod As Node In Main.panemain.GetAllViewsRecursive
			If nod.Tag <> "" Then
				Dim td As tagdata = nod.Tag
				If td.parent <> Null And td.parent <> "null" Then
					If td.parent = currtd.id Then
						Main.panemain.AddNode(nod,nod.Left,nod.Top,nod.PrefWidth,nod.PrefHeight)
						td.parent = Null
						nod.Tag = td
					End If
				End If
			End If
		Next
	End If
	component_info_module.fill_tv1
End Sub

Private Sub pnl_MouseClicked(EventData As MouseEvent)
	Dim view As B4XView = Sender
	Main.currpane = view
	Main.show_component_info(view)
	Main.currnode = view
End Sub
Private Sub pnl_MouseDragged (EventData As MouseEvent)
	Dim nod As Node = Sender
	Dim td As tagdata = nod.Tag
	If td.parent <> Null And td.parent <> "null" Then Return
	Main.panepressed = True
	If Main.resizing = False Then
		' code from xulihang
		Dim event As JavaObject = EventData
		Dim offsetX, offsetY As Double
		offsetX = event.RunMethod("getSceneX",Null) - pressedX
		offsetY =  event.RunMethod("getSceneY",Null)- pressedY
		nod.Left = nod.Left + offsetX
		nod.Top = nod.Top + offsetY
		pressedX = event.RunMethod("getSceneX",Null)
		pressedY = event.RunMethod("getSceneY",Null)
	Else
		nod.As(Pane).MouseCursor = fx.Cursors.CLOSED_HAND
		CSSUtils.SetBorder(nod,10,fx.Colors.Blue,0)
	End If
	Main.currpane = nod
	Main.currnode = nod
End Sub
Private Sub pnl_MouseEntered (EventData As MouseEvent)
End Sub
Private Sub pnl_MouseExited (EventData As MouseEvent)
	Main.panepressed = False
	Dim view As B4XView = Sender
	view.As(Pane).MouseCursor = fx.Cursors.MOVE
	Main.set_border(view)
End Sub
Private Sub pnl_MousePressed (EventData As MouseEvent)
	' code from xulihang
	Dim event As JavaObject = EventData
	pressedX = event.RunMethod("getSceneX",Null)
	pressedY = event.RunMethod("getSceneY",Null)
	'
	Main.panepressed = True
	Dim view As B4XView = Sender
	Dim td As tagdata = view.Tag
	td.PressedX = EventData.X
	td.PressedY = EventData.Y
	view.Tag = td
	Main.xpress = EventData.X
	Main.ypress = EventData.Y
	If td.PressedX <= Main.edgewidth Or td.PressedX >= view.Width - Main.edgewidth  Then Main.resizing = True
	If td.PressedY <= Main.edgewidth Or td.PressedY >= view.Height - Main.edgewidth  Then Main.resizing = True
	Main.lxpos = td.PressedX + view.Left
	Main.lypos = td.PressedY + view.Top
End Sub
Private Sub pnl_MouseReleased (EventData As MouseEvent)
	Dim view As B4XView = Sender
	Main.panepressed = False
	Main.resizing = False
	Main.snap_to_grid(view)
End Sub
Private Sub pnl_MouseMoved (EventData As MouseEvent)
	Main.panepressed = True
	Dim view As B4XView = Sender
	Dim td As tagdata = view.Tag
	If td.parent <> Null And td.parent <> "null" Then Return
	Dim rightsizing As Int = view.Width - Main.edgewidth
	Dim downsizing As Int = view.Height - Main.edgewidth
	Dim leftsizing As Int = Main.edgewidth
	Dim topsizing As Int = Main.edgewidth
	If EventData.X > rightsizing Or EventData.Y > downsizing Or EventData.X < leftsizing Or EventData.Y < topsizing Then
		view.As(Pane).MouseCursor = fx.Cursors.OPEN_HAND
		CSSUtils.SetBorder(view,10,fx.Colors.Blue,0)
	Else
		view.As(Pane).MouseCursor = fx.Cursors.MOVE
		Main.set_border(view)
	End If
End Sub
